#pragma once
#include <Windows.h>
#include <optional>
#include <cstdint>
#include <unordered_map>

namespace temple::checks::callcheck
{
	std::optional<std::uintptr_t> get_associated_function(std::uintptr_t);
	extern std::unordered_map<std::uintptr_t, std::string> pooprecord;
	void copy_temple_function(std::uintptr_t, std::uintptr_t);
	void push_temple_function(std::uintptr_t, std::uintptr_t, int = 0, int = 0);
	bool hook_createevent();
	bool is_temple_cclosure(std::uintptr_t);
}