#include "checks.h"

#include <rbx/memory/memdata/memdata.h>

#include "exceptionhandler/exceptionhandler.h"
#include "crashhandler/crashhandler.h"
#include "cheatengine/cheatengine.h"
#include "trustcheck/trustcheck.h"
#include "callcheck/callcheck.h"

#include <filesystem>
#include <fstream>
#include <string>
#include <cstdint>

#include <iostream>

namespace temple::checks
{

	bool bypass_checks()
	{
		if (!callcheck::hook_createevent())
		{
			return false;
		}

		if (!trustcheck::hook_getmodulefilename())
		{
			return false;
		}

		/*if (!cheatengine::hook_enumwindows())
		{
			return false;
		}*/

		/*if (!exceptionhandler::hook_raiseexception())
		{
			return false;
		}*/

		if (!crashhandler::hook_createfilea())
		{
			return false;
		}

		/* Old TrustCheck bypass - To Be Removed */
		//*reinterpret_cast<std::uintptr_t*>(memdata::vars::trustcheck_link) = reinterpret_cast<std::uintptr_t>(&null_terminator);


		return true;
	}
}