#include "execution.h"

#include <transpiler/serializer/serializer.h>
#include <rbx/memory/functions/functions.h>
#include <rbx/memory/memdata/memdata.h>
#include <temple/config/config.h>
#include <themida/ThemidaSDK.h>
#include <Windows.h>
#include <ui/bridge.h>
#include <util/util.h>
#include <http/http.h>
#include <exception>
#include <iostream>
#include <fstream>
#include <xorstr.h>

#include <util/bitwise.h>

namespace temple::lua::execution
{
	void create_script_global(std::uintptr_t thread)
	{
		functions::lua::getfield(thread, -10002, xorstr("Instance"));
		functions::lua::getfield(thread, -1, xorstr("new"));

		functions::lua::pushstring(thread, xorstr("LocalScript"));

		functions::lua::pcall(thread, 1, 1, 0);

		functions::lua::setfield(thread, -10002, xorstr("script"));

		functions::lua::pop(thread, 1);
	}

	void run_autoexec(std::uintptr_t thread)
	{
		//auto bitlib = temple::http::get("https://temple.cx/scripts/bitlib.lua");
		auto res = temple::http::get(xorstr("https://temple.cx/scripts/autoexec.lua"));

		if (!res.has_value())
		{
			//std::cout << "your mom is a fucking whore bitch\n";
		}
		else
		{
			//std::string autoexec = *bitlib + *res;
			//temple::lua::execution::load_script(thread, *bitlib);
			//temple::functions::lua::spawn(thread);
			//functions::lua::settop(thread, 0);
			temple::lua::execution::load_script(thread, *res);
			temple::functions::lua::spawn(thread);
			//functions::lua::settop(thread, 0);
		}
	}

	void load_script(std::uintptr_t thread, const std::string& script, const std::string& chunkname)
	{
		transpiler::serializer serializer;

		auto bytecode = serializer.serialize(script);

		if (!bytecode[0])
		{
			functions::lua::pushstring(thread, &bytecode[1]);

			return;
		}

		functions::lua::load(thread, chunkname.c_str(), bytecode.c_str(), bytecode.length(), 0);
	}

	std::string serialize_script(const std::string& script)
	{
		transpiler::serializer serializer;

		auto bytecode = serializer.serialize(script);
		
		/*
		std::ofstream ah("C:\\Users\\dicue\\Desktop\\souljaboyupinio.txt");
		
		for (std::size_t i = 0; i < bytecode.size(); i++)
		{
			ah << "\\x";
			std::uint8_t byte = bytecode[i];
			std::string hex_table = "0123456789ABCDEF";
			std::string result = "";

			for(int nig = 0; nig < 2; nig++)
			{
				result = hex_table[byte % 16] + result;
				byte /= 16;
			}

			ah << result;
		}

		ah << "\n";*/

		return bytecode;
	}

	std::string serialize_script_nodebug(const std::string& script)
	{
		transpiler::serializer serializer{ false };

		auto bytecode = serializer.serialize(script);

		return bytecode;
	}

	void execute_bytecode(std::uintptr_t thread, const std::string& bytecode)
	{
		
			thread = functions::lua::newthread(thread);

			functions::lua::sandboxthread(thread, temple::config::lua::identity);

			create_script_global(thread);
			functions::lua::load(thread, "", bytecode.c_str(), bytecode.length(), 0);
			functions::lua::spawn(thread);
			//functions::lua::settop(thread, 0);
	
	}
	
	void execute(std::uintptr_t thread, const std::string& script, bool talktopipe)
	{
		
			transpiler::serializer serializer;

			//std::cout << script << "\n";

			auto bytecode = serializer.serialize(script);

			if (!bytecode[0])
			{
				//std::cout << "-- Execution error!\n";
				if (talktopipe)
					ui::bridge::write_pipe_string(std::string(&bytecode[1]));

				return;
			}
			else
				if (talktopipe)
					ui::bridge::write_pipe_int(0);

			//auto extra_space = *reinterpret_cast<std::uintptr_t*>(*thread + 112);
			//*reinterpret_cast<std::uint16_t*>(extra_space + 24) = 7;
			thread = functions::lua::newthread(thread);

			//functions::lua::sandboxthread(thread, temple::config::lua::identity);

			//create_script_global(thread);

			functions::lua::load(thread, "", bytecode.c_str(), bytecode.length(), 0);
			functions::lua::spawn(thread);
			functions::lua::settop(thread, 0);
		
	}

	void autoexecute(temple::lua::state thread)
	{
		for (const auto& path : temple::util::file::get_files(temple::config::util::current_path + xorstr("\\autoexec\\")))
		{
			execute(*thread, *temple::util::file::read_file(path), false);
		}
	}
}