#include "injection.hpp"

#include "injectionconfig.hpp"

#include <filesystem>
#include <Windows.h>
#include <TlHelp32.h>
#include <Psapi.h>
#include <cstdint>
#include <string>
#include <time.h>

namespace inject
{
    struct process
    {
        HANDLE handle = nullptr;
        std::uint32_t pid = 0;

        process(HANDLE handle, int pid) : handle(handle), pid(pid) {}
        process(){}
    };

    process get_process(const wchar_t* process_name)
    {
        HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
        if (snapshot == INVALID_HANDLE_VALUE)
            return process{};

        process process{};

        PROCESSENTRY32 process_info;
        process_info.dwSize = sizeof(process_info);

        if (Process32First(snapshot, &process_info))
        {
            do
            {
                if (!lstrcmp(process_info.szExeFile, process_name))
                {
                    process.handle = OpenProcess(PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_VM_OPERATION | 
                        PROCESS_CREATE_THREAD, FALSE, process_info.th32ProcessID);

                    process.pid = process_info.th32ProcessID;
                    break;
                }
            } while (Process32Next(snapshot, &process_info));
        }
        CloseHandle(snapshot);

        return process;
    }

    std::uintptr_t get_module(std::uint32_t pid, const wchar_t* name)
    {
        auto snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pid);

        MODULEENTRY32 module_info;
        module_info.dwSize = sizeof(MODULEENTRY32W);

        if (snapshot != INVALID_HANDLE_VALUE)
        {
            if (Module32First(snapshot, &module_info))
            {
                do
                {
                    if (std::wstring(module_info.szExePath).find(name) != std::wstring::npos)
                    {
                        CloseHandle(snapshot);

                        return std::bit_cast<std::uintptr_t>(module_info.modBaseAddr);
                    }
                } while (Module32Next(snapshot, &module_info));
            }
        }

        CloseHandle(snapshot);
        return 0;
    }

    bool temple_open(std::uint32_t pid)
    {
        auto snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pid);

        MODULEENTRY32 module_info;
        module_info.dwSize = sizeof(MODULEENTRY32W);

        if (snapshot != INVALID_HANDLE_VALUE)
        {
            if (Module32First(snapshot, &module_info))
            {
                do
                {
                    if (std::wstring(module_info.szExePath).find(L"Temp") != std::wstring::npos)
                    {
                        CloseHandle(snapshot);

                        return true;
                    }
                } while (Module32Next(snapshot, &module_info));
            }
        }

        CloseHandle(snapshot);
        return false;
    }

    void close_extra_processes(const wchar_t* process_name)
    {
        HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
        if (snapshot == INVALID_HANDLE_VALUE)
            return;

        bool first = true;

        PROCESSENTRY32 process_info;
        process_info.dwSize = sizeof(process_info);

        if (Process32First(snapshot, &process_info))
        {
            do
            {
                if (!lstrcmp(process_info.szExeFile, process_name))
                {
                    auto handle = OpenProcess(PROCESS_ALL_ACCESS, FALSE, process_info.th32ProcessID);

                    PROCESS_MEMORY_COUNTERS pmc;

                    if (GetProcessMemoryInfo(handle, &pmc, sizeof(pmc)))
                    {
                        if (handle && (pmc.PeakPagefileUsage / 1000000) < 50)
                        {
                            TerminateProcess(handle, 0);

                            CloseHandle(handle);
                        }
                    }
                }
            } while (Process32Next(snapshot, &process_info));
        }
        CloseHandle(snapshot);
    }

    bool bypass_ldrloaddll(HANDLE handle, std::uint32_t pid)
    {
        std::byte* ldrptr = std::bit_cast<std::byte*>(ldrloaddll_og);
        std::ptrdiff_t ldr_posstart = 320;

        auto base = get_module(pid, L"RobloxPlayerBeta.exe");

        auto loadlibraryexw = std::bit_cast<std::byte*>(GetProcAddress(GetModuleHandle(L"kernelbase"), "LoadLibraryExW"));

        std::byte buffer[100];

        ReadProcessMemory(handle, loadlibraryexw + ldr_posstart, buffer, 100, nullptr);

        for (int i = 0; i < 100; i++)
        {
            if (*std::bit_cast<std::uint32_t*>(&buffer[i]) == 0x15FF5051)
            {
                std::byte* ldr_ptr = ldrptr + base;
                WriteProcessMemory(handle, loadlibraryexw + ldr_posstart + i + 4, &ldr_ptr, sizeof(ldr_ptr), nullptr);
                
                return true;
            }
        }

        MessageBoxA(nullptr, "There was a problem while injecting, tell Kronix!", "Temple Error :(", MB_OK);

        return false;
    }

    std::string spoof_path(const char* dllname)
    {
        std::string possible_chars{ "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTZUVWXYZ0123456789" };

        char path_buff[MAX_PATH];
        GetFullPathNameA(dllname, MAX_PATH, path_buff, nullptr);

        auto temp = std::filesystem::temp_directory_path().string();

        std::string new_filename{};

        srand(time(nullptr));

        do
        {
            new_filename = "";

            for (std::size_t i = 0; i < 10; i++)
            {
                new_filename += possible_chars[rand() % 63];
            }
        } while (std::filesystem::exists(temp + "\\" + new_filename + ".dll"));

        std::string new_dll_path = temp + "\\" + new_filename + ".dll";

        std::filesystem::copy_file(std::string_view{ path_buff }, new_dll_path);

        return new_dll_path;
    }

    bool loadlibrary_inject(HANDLE process, std::string dll_path)
    {
        auto dllpath_addr = VirtualAllocEx(process, nullptr, MAX_PATH,
            MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);

        if (!dllpath_addr)
            return false;

        if (!WriteProcessMemory(process, dllpath_addr, dll_path.c_str(), 
            dll_path.length(), nullptr))
        {
        fail:
            VirtualFreeEx(process, dllpath_addr, 0, MEM_RELEASE);
            return false;
        }

        auto kernel32 = GetModuleHandle(L"kernel32.dll");

        if (!kernel32)
        {
            goto fail;
        }

        auto loadlibrary = GetProcAddress(kernel32, "LoadLibraryA");

        if (!loadlibrary)
        {
            goto fail;
        }

        auto thread = CreateRemoteThread(process, nullptr, 0,
            std::bit_cast<LPTHREAD_START_ROUTINE>(loadlibrary), dllpath_addr, 0, nullptr);

        if (!thread)
        {
            goto fail;
        }

        WaitForSingleObject(thread, INFINITE);

        DWORD exit_code;
        GetExitCodeThread(thread, &exit_code);


        CloseHandle(thread);
        VirtualFreeEx(process, dllpath_addr, 0, MEM_RELEASE);

        return exit_code;
    }

    bool temple_injected()
    {
        //auto rbx = get_process(L"RobloxPlayerBeta.exe");

        //auto res = get_module(rbx.pid, L"temple.dll") != 0;


        //return std::filesystem::exists("\\\\.\\pipe\\HentaiGirlsBest");
        /*
        WIN32_FIND_DATAW fd; // ty kind stackoverflow
        DWORD dwErrCode;

        HANDLE hFind = FindFirstFileW(L"\\\\.\\pipe\\HentaiGirlsBest", &fd);
        if (hFind == INVALID_HANDLE_VALUE)
        {
           // MessageBox(0, L"kys", L"cuummy gummy", MB_OK);
            dwErrCode = GetLastError();
        }
        else
        {
            do
            {
               // MessageBox(0, fd.cFileName, L"cuummy gummy", MB_OK);
                if (wcscmp(L"HentaiGirlsBest",fd.cFileName) == 0)
                {
                    FindClose(hFind);
                    return true;
                }
            } while (FindNextFileW(hFind, &fd));

            dwErrCode = GetLastError();
            FindClose(hFind);
        }

        if ((dwErrCode != ERROR_FILE_NOT_FOUND) &&
            (dwErrCode != ERROR_NO_MORE_FILES))
        {
            return false;
        }*/

        return temple_open(get_process(L"RobloxPlayerBeta.exe").pid);
    }

    bool inject()
    {
        close_extra_processes(L"RobloxPlayerBeta.exe");

        auto rbx = get_process(L"RobloxPlayerBeta.exe");

        bypass_ldrloaddll(rbx.handle, rbx.pid);

        auto res = loadlibrary_inject(rbx.handle, spoof_path(dll_path.c_str()));

        CloseHandle(rbx.handle);

        return res;
    }
}