#pragma once

#include <rbx/structs/lua.h>

#include <string>

namespace temple::lua::execution
{
	void execute_bytecode(std::uintptr_t, const std::string&);
	std::string serialize_script(const std::string&);
	std::string serialize_script_nodebug(const std::string& script);

	void load_script(std::uintptr_t, const std::string&, const std::string& = "");
	void execute(std::uintptr_t, const std::string&, bool = true);
	void run_autoexec(std::uintptr_t thread);
	void autoexecute(temple::lua::state);
}