#pragma once
#include <cstdint>
#include <string>
#include <vector>
#include <memory>

namespace temple::rbx
{
	struct instance
	{
		std::uint32_t padding[9];
		std::string& name;
		std::shared_ptr<std::vector<std::shared_ptr<instance>>> children;
		instance* parent;
	};
}