#include "lua.h"

#include <rbx/memory/functions/functions.h>

namespace temple::lua
{
	tvalue* &state::get_top()
	{
		return functions::lua::state::get_top(*this);
	}

	void state::set_top(tvalue* v)
	{
		auto& top = functions::lua::state::get_top(*this);
		top = v;
	}

	tvalue* &state::get_base()
	{
		return functions::lua::state::get_base(*this);
	}

	void state::set_base(tvalue* v)
	{
		auto& base = functions::lua::state::get_base(*this);
		base = v;
	}

	extraspace* state::get_extraspace()
	{
		return functions::lua::state::get_extraspace(*this);
	}

	std::uintptr_t state::get_closure()
	{
		return functions::lua::state::get_closure(*this);
	}

	std::uintptr_t state::get_l_g()
	{
		return functions::lua::state::get_l_g(*this);
	}
}