#pragma once

#include <cstdint>
#include <string>

namespace temple::util::bitwise
{
	std::uint32_t rotl32(std::uint32_t, unsigned int);
	std::uint32_t rotr32(std::uint32_t, unsigned int);
	std::uint64_t rotl64(std::uint64_t, unsigned int);
	std::uint64_t rotr64(std::uint64_t, unsigned int);

	std::uint64_t bswap64(std::uint64_t);
	std::uint32_t bswap(std::uint32_t);
	std::string to_hex(std::uint64_t);
}
