#include "yara.h"

#include <Windows.h>
#include <TlHelp32.h>
#include <Psapi.h>
#include <thread>
#include <chrono>

namespace temple::yara
{
    void check_yara_process()
    {
        HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
        if (snapshot == INVALID_HANDLE_VALUE)
            return;

        bool first = true;

        PROCESSENTRY32 process_info;
        process_info.dwSize = sizeof(process_info);

        if (Process32First(snapshot, &process_info))
        {
            do
            {
                if (!lstrcmp(process_info.szExeFile, L"RobloxPlayerBeta.exe"))
                {
                    auto handle = OpenProcess(PROCESS_ALL_ACCESS, FALSE, process_info.th32ProcessID);

                    PROCESS_MEMORY_COUNTERS pmc;

                    if (GetProcessMemoryInfo(handle, &pmc, sizeof(pmc)))
                    {
                        if (handle && (pmc.PeakPagefileUsage / 1000000) < 50)
                        {
                            TerminateProcess(handle, 0);

                            CloseHandle(handle);

                            CloseHandle(snapshot);

                            return;
                        }
                    }
                }
            } while (Process32Next(snapshot, &process_info));
        }
        CloseHandle(snapshot);
    }

	void yara_process_task()
	{
        while (true)
        {
            check_yara_process();

            std::this_thread::sleep_for(std::chrono::milliseconds(1000));
        }
	}
}